diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index 5ea348fb8..3f8cca862 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -1,7 +1,5 @@
 package net.minecraft.core.block;
 
-import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
@@ -13,9 +11,9 @@ import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.slf4j.Logger;
 
 import java.util.Objects;
 
@@ -28,12 +26,13 @@ public class BlockLogicChest
     }
 
     @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         @NotNull Direction direction = mob.getHorizontalPlacementDirection(side).getOpposite();
         @NotNull Type type = Type.SINGLE;
 
+        TilePos queryPos = new TilePos();
         if (mob.isSneaking() && side.isHorizontal() && (mob.rotationLockHorizontal == null || mob.rotationLockHorizontal == Direction.NONE)) {
-            final @NotNull TilePos placedOn = tilePos.sub(side.getDirection());
+            final @NotNull TilePos placedOn = tilePos.sub(side.getDirection(), new TilePos());
 
             if (isSingleChest(world, placedOn)) {
                 final @NotNull Direction direction2 = getDirectionFromMeta(world.getBlockData(placedOn));
@@ -88,43 +87,43 @@ public class BlockLogicChest
             }
         } else if (!mob.isSneaking()) {
             if (direction == Direction.NORTH) {
-                if (isSingleChestWithDirection(world, tilePos.west(), direction) && !isSingleChestWithDirection(world, tilePos.east(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.west(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.east(queryPos), direction)) {
                     type = Type.LEFT;
-                    setType(world, tilePos.west(), Type.RIGHT);
+                    setType(world, tilePos.west(queryPos), Type.RIGHT);
                 }
-                if (isSingleChestWithDirection(world, tilePos.east(), direction) && !isSingleChestWithDirection(world, tilePos.west(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.east(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.west(queryPos), direction)) {
                     type = Type.RIGHT;
-                    setType(world, tilePos.east(), Type.LEFT);
+                    setType(world, tilePos.east(queryPos), Type.LEFT);
                 }
             }
             if (direction == Direction.EAST) {
-                if (isSingleChestWithDirection(world, tilePos.north(), direction) && !isSingleChestWithDirection(world, tilePos.south(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.north(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.south(queryPos), direction)) {
                     type = Type.LEFT;
-                    setType(world, tilePos.north(), Type.RIGHT);
+                    setType(world, tilePos.north(queryPos), Type.RIGHT);
                 }
-                if (isSingleChestWithDirection(world, tilePos.south(), direction) && !isSingleChestWithDirection(world, tilePos.north(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.south(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.north(queryPos), direction)) {
                     type = Type.RIGHT;
-                    setType(world, tilePos.south(), Type.LEFT);
+                    setType(world, tilePos.south(queryPos), Type.LEFT);
                 }
             }
             if (direction == Direction.SOUTH) {
-                if (isSingleChestWithDirection(world, tilePos.west(), direction) && !isSingleChestWithDirection(world, tilePos.east(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.west(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.east(queryPos), direction)) {
                     type = Type.RIGHT;
-                    setType(world, tilePos.west(), Type.LEFT);
+                    setType(world, tilePos.west(queryPos), Type.LEFT);
                 }
-                if (isSingleChestWithDirection(world, tilePos.east(), direction) && !isSingleChestWithDirection(world, tilePos.west(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.east(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.west(queryPos), direction)) {
                     type = Type.LEFT;
-                    setType(world, tilePos.east(), Type.RIGHT);
+                    setType(world, tilePos.east(queryPos), Type.RIGHT);
                 }
             }
             if (direction == Direction.WEST) {
-                if (isSingleChestWithDirection(world, tilePos.north(), direction) && !isSingleChestWithDirection(world, tilePos.south(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.north(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.south(queryPos), direction)) {
                     type = Type.RIGHT;
-                    setType(world, tilePos.north(), Type.LEFT);
+                    setType(world, tilePos.north(queryPos), Type.LEFT);
                 }
-                if (isSingleChestWithDirection(world, tilePos.south(), direction) && !isSingleChestWithDirection(world, tilePos.north(), direction)) {
+                if (isSingleChestWithDirection(world, tilePos.south(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.north(queryPos), direction)) {
                     type = Type.LEFT;
-                    setType(world, tilePos.south(), Type.RIGHT);
+                    setType(world, tilePos.south(queryPos), Type.RIGHT);
                 }
             }
         }
@@ -137,48 +136,48 @@ public class BlockLogicChest
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         final Direction direction = side.getDirection();
         Type type = Type.SINGLE;
-
+        TilePos queryPos = new TilePos();
         if (direction == Direction.NORTH) {
-            if (isSingleChestWithDirection(world, tilePos.west(), direction) && !isSingleChestWithDirection(world, tilePos.east(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.west(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.east(queryPos), direction)) {
                 type = Type.LEFT;
-                setType(world, tilePos.west(), Type.RIGHT);
+                setType(world, tilePos.west(queryPos), Type.RIGHT);
             }
-            if (isSingleChestWithDirection(world, tilePos.east(), direction) && !isSingleChestWithDirection(world, tilePos.west(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.east(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.west(queryPos), direction)) {
                 type = Type.RIGHT;
-                setType(world, tilePos.east(), Type.LEFT);
+                setType(world, tilePos.east(queryPos), Type.LEFT);
             }
         }
         if (direction == Direction.EAST) {
-            if (isSingleChestWithDirection(world, tilePos.north(), direction) && !isSingleChestWithDirection(world, tilePos.south(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.north(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.south(queryPos), direction)) {
                 type = Type.LEFT;
-                setType(world, tilePos.north(), Type.RIGHT);
+                setType(world, tilePos.north(queryPos), Type.RIGHT);
             }
-            if (isSingleChestWithDirection(world, tilePos.south(), direction) && !isSingleChestWithDirection(world, tilePos.north(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.south(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.north(queryPos), direction)) {
                 type = Type.RIGHT;
-                setType(world, tilePos.south(), Type.LEFT);
+                setType(world, tilePos.south(queryPos), Type.LEFT);
             }
         }
         if (direction == Direction.SOUTH) {
-            if (isSingleChestWithDirection(world, tilePos.west(), direction) && !isSingleChestWithDirection(world, tilePos.east(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.west(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.east(queryPos), direction)) {
                 type = Type.RIGHT;
-                setType(world, tilePos.west(), Type.LEFT);
+                setType(world, tilePos.west(queryPos), Type.LEFT);
             }
-            if (isSingleChestWithDirection(world, tilePos.east(), direction) && !isSingleChestWithDirection(world, tilePos.west(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.east(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.west(queryPos), direction)) {
                 type = Type.LEFT;
-                setType(world, tilePos.east(), Type.RIGHT);
+                setType(world, tilePos.east(queryPos), Type.RIGHT);
             }
         }
         if (direction == Direction.WEST) {
-            if (isSingleChestWithDirection(world, tilePos.north(), direction) && !isSingleChestWithDirection(world, tilePos.south(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.north(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.south(queryPos), direction)) {
                 type = Type.RIGHT;
-                setType(world, tilePos.north(), Type.LEFT);
+                setType(world, tilePos.north(queryPos), Type.LEFT);
             }
-            if (isSingleChestWithDirection(world, tilePos.south(), direction) && !isSingleChestWithDirection(world, tilePos.north(), direction)) {
+            if (isSingleChestWithDirection(world, tilePos.south(queryPos), direction) && !isSingleChestWithDirection(world, tilePos.north(queryPos), direction)) {
                 type = Type.LEFT;
-                setType(world, tilePos.south(), Type.RIGHT);
+                setType(world, tilePos.south(queryPos), Type.RIGHT);
             }
         }
 
@@ -189,7 +188,7 @@ public class BlockLogicChest
         world.setBlockData(tilePos, meta);
     }
 
-    public void checkIfOtherHalfExists(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void checkIfOtherHalfExists(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
         final @NotNull Type type = getTypeFromMeta(meta);
 
@@ -236,10 +235,11 @@ public class BlockLogicChest
         if (world.isClientSide) {
             return;
         }
-        final int bN = world.getBlockId(tilePos.north());
-        final int bS = world.getBlockId(tilePos.south());
-        final int bW = world.getBlockId(tilePos.west());
-        final int bE = world.getBlockId(tilePos.east());
+        TilePos queryPos = new TilePos();
+        final int bN = world.getBlockId(tilePos.north(queryPos));
+        final int bS = world.getBlockId(tilePos.south(queryPos));
+        final int bW = world.getBlockId(tilePos.west(queryPos));
+        final int bE = world.getBlockId(tilePos.east(queryPos));
         @NotNull Direction direction = Direction.NORTH;
         if (Blocks.solid[bN] && !Blocks.solid[bS]) {
             direction = Direction.SOUTH;
@@ -258,12 +258,12 @@ public class BlockLogicChest
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         super.onNeighborChanged(world, tilePos, id);
         this.checkIfOtherHalfExists(world, tilePos);
     }
 
-    public static boolean isChest(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public static boolean isChest(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> b = world.getBlock(tilePos);
         return b != null && b.getLogic() instanceof BlockLogicChest;
     }
@@ -283,7 +283,7 @@ public class BlockLogicChest
         }
     }
 
-    public static void setType(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Type type) {
+    public static void setType(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Type type) {
         if (isChest(world, tilePos)) {
             world.setBlockDataNotify(tilePos, getMetaWithType(world.getBlockData(tilePos), type));
         }
@@ -297,16 +297,16 @@ public class BlockLogicChest
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         if (world.isClientSide) return true;
 
         this.checkIfOtherHalfExists(world, tilePos);
-        player.displayChestScreen(getInventory(world, tilePos), tilePos.x, tilePos.y, tilePos.z);
+        player.displayChestScreen(getInventory(world, tilePos), tilePos.x(), tilePos.y(), tilePos.z());
 
         return true;
     }
 
-    public static @NotNull Container getInventory(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public static @NotNull Container getInventory(final @NotNull World world, final @NotNull TilePosc tilePos) {
         @NotNull Container inventory = (Container) Objects.requireNonNull(world.getTileEntity(tilePos));
 
         final int meta = world.getBlockData(tilePos);
@@ -399,7 +399,7 @@ public class BlockLogicChest
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataRaw(tilePos, Blocks.CHEST_PLANKS_OAK_PAINTED.id(), meta);
         world.setBlockData(tilePos, meta);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
index 8e63303c9..8f4b5120e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
@@ -4,7 +4,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.block.BlockLogicChest.Type;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityChest;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -12,6 +12,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -22,7 +23,7 @@ public class BlockLogicChestLegacy
     extends BlockLogic {
 
     public BlockLogicChestLegacy(final @NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
         block.withEntity(TileEntityChest::new);
     }
 
@@ -33,22 +34,22 @@ public class BlockLogicChestLegacy
         } else return null;
     }
 
-    public static boolean isLegacyChest(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public static boolean isLegacyChest(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = world.getBlock(tilePos);
         return block == Blocks.CHEST_LEGACY || block == Blocks.CHEST_LEGACY_PAINTED;
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         final @Nullable TileEntity entity = world.getTileEntity(tilePos);
         if (entity != null) {
-            entity.dropContents(world, tilePos.x, tilePos.y, tilePos.z);
+            entity.dropContents(world, tilePos.x(), tilePos.y(), tilePos.z());
         }
         super.onRemoved(world, tilePos, data);
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         if (world.isClientSide) {
             return true;
         }
@@ -60,20 +61,21 @@ public class BlockLogicChestLegacy
         return Objects.requireNonNull(world.getBlock(tilePos)).onInteracted(world, tilePos, player, side, xHit, yHit);
     }
 
-    private void updateLegacyChest(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private void updateLegacyChest(final @NotNull World world, final @NotNull TilePosc tilePos) {
         @NotNull Direction facingDirection = Direction.SOUTH;
         @Nullable Direction otherChestDirection = null;
 
-        if (isLegacyChest(world, tilePos.east())) {
+        TilePos queryPos = new TilePos();
+        if (isLegacyChest(world, tilePos.east(queryPos))) {
             otherChestDirection = Direction.EAST;
         }
-        if (isLegacyChest(world, tilePos.west())) {
+        if (isLegacyChest(world, tilePos.west(queryPos))) {
             otherChestDirection = Direction.WEST;
         }
-        if (isLegacyChest(world, tilePos.south())) {
+        if (isLegacyChest(world, tilePos.south(queryPos))) {
             otherChestDirection = Direction.SOUTH;
         }
-        if (isLegacyChest(world, tilePos.north())) {
+        if (isLegacyChest(world, tilePos.north(queryPos))) {
             otherChestDirection = Direction.NORTH;
         }
 
@@ -81,16 +83,16 @@ public class BlockLogicChestLegacy
             //Single Chest
 
             int meta = world.getBlockData(tilePos);
-            if (world.isBlockOpaqueCube(tilePos.east()) && !world.isBlockOpaqueCube(tilePos.west())) {
+            if (world.isBlockOpaqueCube(tilePos.east(queryPos)) && !world.isBlockOpaqueCube(tilePos.west(queryPos))) {
                 facingDirection = Direction.WEST;
             }
-            if (world.isBlockOpaqueCube(tilePos.west()) && !world.isBlockOpaqueCube(tilePos.east())) {
+            if (world.isBlockOpaqueCube(tilePos.west(queryPos)) && !world.isBlockOpaqueCube(tilePos.east(queryPos))) {
                 facingDirection = Direction.EAST;
             }
-            if (world.isBlockOpaqueCube(tilePos.south()) && !world.isBlockOpaqueCube(tilePos.north())) {
+            if (world.isBlockOpaqueCube(tilePos.south(queryPos)) && !world.isBlockOpaqueCube(tilePos.north(queryPos))) {
                 facingDirection = Direction.NORTH;
             }
-            if (world.isBlockOpaqueCube(tilePos.north()) && !world.isBlockOpaqueCube(tilePos.south())) {
+            if (world.isBlockOpaqueCube(tilePos.north(queryPos)) && !world.isBlockOpaqueCube(tilePos.south(queryPos))) {
                 facingDirection = Direction.SOUTH;
             }
 
@@ -117,25 +119,25 @@ public class BlockLogicChestLegacy
 
             if (otherChestDirection == Direction.NORTH) {
                 facingDirection = Direction.EAST;
-                if (world.isBlockOpaqueCube(tilePos.east()) || world.isBlockOpaqueCube(tilePos.east().north())) {
+                if (world.isBlockOpaqueCube(tilePos.east(queryPos)) || world.isBlockOpaqueCube(tilePos.east(queryPos).north(queryPos))) {
                     facingDirection = Direction.WEST;
                 }
             }
             if (otherChestDirection == Direction.SOUTH) {
                 facingDirection = Direction.EAST;
-                if (world.isBlockOpaqueCube(tilePos.east()) || world.isBlockOpaqueCube(tilePos.east().south())) {
+                if (world.isBlockOpaqueCube(tilePos.east(queryPos)) || world.isBlockOpaqueCube(tilePos.east(queryPos).south(queryPos))) {
                     facingDirection = Direction.WEST;
                 }
             }
             if (otherChestDirection == Direction.EAST) {
                 facingDirection = Direction.SOUTH;
-                if (world.isBlockOpaqueCube(tilePos.south()) || world.isBlockOpaqueCube(tilePos.east().south())) {
+                if (world.isBlockOpaqueCube(tilePos.south(queryPos)) || world.isBlockOpaqueCube(tilePos.east(queryPos).south(queryPos))) {
                     facingDirection = Direction.NORTH;
                 }
             }
             if (otherChestDirection == Direction.WEST) {
                 facingDirection = Direction.SOUTH;
-                if (world.isBlockOpaqueCube(tilePos.south()) || world.isBlockOpaqueCube(tilePos.west().south())) {
+                if (world.isBlockOpaqueCube(tilePos.south(queryPos)) || world.isBlockOpaqueCube(tilePos.west(queryPos).south(queryPos))) {
                     facingDirection = Direction.NORTH;
                 }
             }
@@ -178,7 +180,7 @@ public class BlockLogicChestLegacy
         }
     }
 
-    private @NotNull ItemStack @NotNull [] getAndClearChestInventory(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private @NotNull ItemStack @NotNull [] getAndClearChestInventory(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final @NotNull TileEntityChest tileEntityChest = (TileEntityChest) Objects.requireNonNull(world.getTileEntity(tilePos));
 
         final ItemStack[] items = new ItemStack[tileEntityChest.getContainerSize()];
@@ -191,7 +193,7 @@ public class BlockLogicChestLegacy
         return items;
     }
 
-    private void setChestInventory(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull ItemStack @NotNull [] items) {
+    private void setChestInventory(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull ItemStack @NotNull [] items) {
         final @NotNull TileEntityChest tileEntityChest = (TileEntityChest) Objects.requireNonNull(world.getTileEntity(tilePos));
 
         for (int i = 0; i < items.length; i++) {
@@ -199,10 +201,10 @@ public class BlockLogicChestLegacy
         }
     }
 
-    private void updateChestBlock(final @NotNull World world, final @NotNull TilePos tilePos, int newMeta) {
+    private void updateChestBlock(final @NotNull World world, final @NotNull TilePosc tilePos, int newMeta) {
         if (!isLegacyChest(world, tilePos)) {
             if (Global.BUILD_CHANNEL.isUnstableBuild())
-                throw new RuntimeException("Not a Legacy Chest: X: " + tilePos.x + " Y: " + tilePos.y + " Z: " + tilePos.z);
+                throw new RuntimeException("Not a Legacy Chest: X: " + tilePos.x() + " Y: " + tilePos.y() + " Z: " + tilePos.z());
 
             return;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
index d23a6e43b..f36307806 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
@@ -8,7 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -21,7 +21,7 @@ public class BlockLogicChestPainted
     }
 
     @Override
-    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         return itemStack.getMetadata();
     }
 
@@ -49,13 +49,13 @@ public class BlockLogicChestPainted
     }
 
     @Override
-    public void removeDye(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int meta = this.stripColorFromMetadata(world.getBlockData(tilePos));
         world.setBlockIdDataNotify(tilePos, Blocks.CHEST_PLANKS_OAK.id(), meta);
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         IPainted.super.setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicClay.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicClay.java
index 1e2c4ee7a..f26163343 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicClay.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicClay.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicClay extends BlockLogic {
     public BlockLogicClay(final @NotNull Block<?> block) {
-        super(block, Material.clay);
+        super(block, Materials.CLAY);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobble.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobble.java
index e01c787da..6a5a5416c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobble.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobble.java
@@ -5,7 +5,6 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
index 5354a5dc7..d00e4f1d5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
@@ -10,11 +10,11 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicCobweb extends BlockLogic {
     public BlockLogicCobweb(final @NotNull Block<?> block, final @NotNull Material material) {
@@ -22,7 +22,7 @@ public class BlockLogicCobweb extends BlockLogic {
     }
 
     @Override
-    public void onEntityCollision(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity) {
+    public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
         entity.fallDistance = 0;
         entity.stuckInCobweb = true;
     }
@@ -42,7 +42,7 @@ public class BlockLogicCobweb extends BlockLogic {
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return null;
     }
 
@@ -52,7 +52,7 @@ public class BlockLogicCobweb extends BlockLogic {
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 }
